# Release Notes for TECA 2.1.0 #
Fri Mar 17 13:16:26 PDT 2017

* Wind radii calculation. Computes storm size using radial wind profile. The
  max is located, then for each user provided critical wind value the radius is
  computed by finding the first descending crossing. The profile is computed by
  sampling data from 2D lat lon mesh onto a uniformly spaced 1d mesh. There are
  2 sampling methods, average and max. A parallel commamnd line application
  tests and Python bindings have been included.
* Wind Radii plots. Added a command line application to generate summary
  statsitics of wind radii data.
* Compute ACE (Accumulated Cyclonic Energy) Adds calculation and plotting of
  ACE as described here:
  https://en.wikipedia.org/wiki/Accumulated_cyclone_energy
* extended the pipeline model to allow parallel sub-pipeline to generate
  metadata
* CF reader caches metadata. The metadata is parsed and stored in a cache file
  once per dataset. Cache file is tagged by the files regex, as the same regex
  produces the same metadata. This optimization addresses poor I/O performance
  do to time being stored as an unlimtted dimension. Obtaining the metadata
  from the cache takes milliseconds, while scanning the dataset takes many
  minutes for very large datasets.
* Added simple algorithm to capture/inject data from/to a pipeline at any given
  point. This simplifies scripting when you don't need to run inside a TECA
  pipeline.
* Fix TC stats plots labels, spacing, and limits.
* Improvements to TECA's binary stream object which is used for communication
  and I/O.
* Factor stream based I/O code into a utility
* Add stable sort option to TECA's table sort. This allows one to sort while
  preserving ordering of tracks.
* Fix TC stats plot layout bug reported by Michael.
* Add wind radii plots in the TC Trajectory Scalars application. Plot wind
  radii over track position and time relative to the other detection criteria.
* Implemented a numerical expression parser that uses C++ operator notations.
  This lets users specify mathematic experssions to generic filtering and
  computational algorithms as opposed to having to write specific algorithms
  for each filter or computation.
* Updated row based filtering to use the new epxression parser and seperated it
  from geographic filtering. Moved geographic filtering into it's own algorithm.
* Addded an algorithm for computing new variables using user provided expressions
  describing arithemtic operations on existing variables.
* Transitioned to CMake 3.0.0
* Factored geographic filtering code into a utility where it can be reused
  across the project
* Factored Saffir-Simpson scaling code into a utiltiy where it can be reused
  accross the project
* Added the capability for the CF reader to understand requests for time
  values. Previoulsy one had to request the time by index rather than the imt
  evaliue itself.
* Added broadcast to the binary stream and refactored code that was
  broadcasting binary streams to use the new API
* Fix leaking matplotlib figures in TC trajectory scalars plot application.
