# Release Notes for TECA 3.0.0 #

This is a major release in support of:

  T.A. O'Brien et al, **"Detection of Atmospheric Rivers with Inline
  Uncertainty Quantification: TECA-BARD v1.0"**, Geoscientific Model
  Development, submitted winter 2020

The pipeline internals were refactored to be more general, the assumption that
time was the dimension across which the reduction is applied was removed, as
well as changes that enable nested map-reduce.

The TECA User Guide was ported to "Read the Docs". https://teca.readthedocs.io

Our Travis CI test infrastructure was updated to use Docker, and two new OS
images Fedora 28, and Ubuntu 18.04 were deployed.

More than 40 bug fixes

## New algorithms included in this release: ##

| Type                | Name                               | Description                                                                       |
|---------------------|------------------------------------|-----------------------------------------------------------------------------------|
| general puprose     | teca_2d_component_area             | Computes the area's of regions identified by the connected components filter.     |
| general puprose     | teca_bayesian_ar_detect            | Detects atmospheric rivers using a Bayesian method.                               |
| general puprose     | teca_bayesian_ar_detect_parameters | Parameters used by Bayesian AR detector.                                          |
| general puprose     | teca_cartesian_mesh_source         | Used to create Cratesian meshes in memory and inject them into a pipeline.        |
| general puprose     | teca_component_area_filter         | Masks regions with area out side a user specified range                           |
| general puprose     | teca_component_statistics          | Gathers information about connected component regions into a tabular format       |
| general puprose     | teca_latitude_damper               | Multiplies a field by an inverted Gaussian (user specified mean and HWHM)         |
| general puprose     | teca_normalize_coordinates         | Transforms Cartesian meshes such that coordinates are always in ascending order   |
| general puprose     | teca_python_algorithm              | Base class for TECA algorithm's written in Python. Handles internal plumbing      |
| core infrastructure | teca_memory_profiler               | Supporting class that samples memory consumtion during application execution      |
| core infrastructure | teca_profiler                      | Supporting class that logs start, stop, and duration of developer defined events  |
| I/O                 | teca_cartesian_mesh_reader         | Reads TECA Cartesian meshes in TECA's internal binary format                      |
| I/O                 | teca_cartesian_mesh_writer         | Writes TECA Cartesian meshes in TECA's internal binary format                     |
| I/O                 | teca_cf_writer                     | Writes TECA Cratesian meshes in NetCDF CF2 conventions                            |

## New applications included in this release: ##

| Name                     | Description                                                             |
|--------------------------|-------------------------------------------------------------------------|
| teca_bayesian_ar_detect  | Command line application that can be used to detect AR's on HPC systems |
| teca_profile_explorer    | Interactive tool for exploring run time profiling data                  |
